"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request-promise");
function getCurrentIp() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, request('https://api.ipify.org/')];
        });
    });
}
function updateRecords(ip, config) {
    return __awaiter(this, void 0, void 0, function () {
        var recordDefaults, records;
        return __generator(this, function (_a) {
            recordDefaults = {
                type: 'A',
                data: ip,
                ttl: 60 * 10 // 10 minutes (minimum allowed)
            };
            records = config.records;
            // if records is a single object or string wrap it into an array
            if (records.constructor !== Array) {
                records = [records];
            }
            records = records.map(function (record) {
                // if current record is a single string
                // wrap it in array
                if (typeof record === 'string') {
                    record = { name: record };
                }
                return Object.assign({}, recordDefaults, record);
            });
            return [2 /*return*/, Promise.all(records.map(function (record) {
                    var domain = config.domain;
                    if (typeof (record.domain) !== 'undefined') {
                        domain = record.domain;
                        delete record.domain;
                    }
                    var options = {
                        method: 'PUT',
                        url: "https://api.godaddy.com/v1/domains/" + domain + "/records/" + record.type + "/" + record.name.replace('@', '%40'),
                        headers: {
                            'authorization': "sso-key " + config.apiKey + ":" + config.secret,
                            'content-type': 'application/json'
                        },
                        body: [record],
                        json: true
                    };
                    return request(options);
                }))];
        });
    });
}
module.exports = function (RED) {
    function godaddyNode(config) {
        RED.nodes.createNode(this, config);
        var configNode = RED.nodes.getNode(config.confignode);
        if (!configNode) {
            this.error("Config is missing!");
            return;
        }
        var node = this;
        node.config = configNode;
        node.items = config.items;
        node.on('input', function (msg, send, done) {
            return __awaiter(this, void 0, void 0, function () {
                var outMsg, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            done = done || function (text, msg) { if (text) {
                                return node.error(text, msg);
                            } return null; };
                            send = send || function () {
                                var args = [];
                                for (var _i = 0; _i < arguments.length; _i++) {
                                    args[_i] = arguments[_i];
                                }
                                node.send.apply(node, args);
                            };
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            outMsg = RED.util.cloneMessage(msg);
                            return [4 /*yield*/, getDns(node, outMsg)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            node.error(e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        });
    }
    function getDns(node, outMsg) {
        return __awaiter(this, void 0, void 0, function () {
            var currentIp, lastIp, items, _i, items_1, item, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 8, , 9]);
                        return [4 /*yield*/, getCurrentIp()];
                    case 1:
                        currentIp = _a.sent();
                        lastIp = node.context().get('lastIp');
                        if (!(!lastIp || lastIp != currentIp)) return [3 /*break*/, 6];
                        items = node.items;
                        if (outMsg.payload) {
                            if (outMsg.payload.newIp) {
                                currentIp = outMsg.payload.newIp;
                            }
                            if (outMsg.payload.entries) {
                                items = outMsg.payload.entries;
                            }
                        }
                        _i = 0, items_1 = items;
                        _a.label = 2;
                    case 2:
                        if (!(_i < items_1.length)) return [3 /*break*/, 5];
                        item = items_1[_i];
                        return [4 /*yield*/, updateRecords(currentIp, {
                                "apiKey": node.config.key,
                                "secret": node.config.secret,
                                "domain": item.domain,
                                "records": [
                                    { "type": item.type, "name": item.name, "ttl": parseInt(item.ttl) }
                                ]
                            })];
                    case 3:
                        _a.sent();
                        node.debug("[" + new Date() + "] Successfully updated DNS records to ip " + currentIp);
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        node.context().set('lastIp', currentIp);
                        outMsg.dnsUpdate = true;
                        return [3 /*break*/, 7];
                    case 6:
                        outMsg.dnsUpdate = false;
                        _a.label = 7;
                    case 7:
                        outMsg.currentIp = currentIp;
                        node.send(outMsg);
                        return [3 /*break*/, 9];
                    case 8:
                        err_1 = _a.sent();
                        if (err_1 && err_1.message !== 'Nothing to update') {
                            node.error("[" + new Date() + "] " + err_1);
                        }
                        outMsg.dnsUpdate = false;
                        node.send(outMsg);
                        return [3 /*break*/, 9];
                    case 9:
                        ;
                        return [2 /*return*/];
                }
            });
        });
    }
    RED.nodes.registerType("godaddy-node", godaddyNode);
};

//# sourceMappingURL=godaddy.js.map
